package com.sun.org.apache.xalan.internal.xsltc.compiler;

import com.sun.org.apache.bcel.internal.generic.ConstantPoolGen;
import com.sun.org.apache.bcel.internal.generic.PUSH;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.MethodGenerator;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.ClassGenerator;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.TypeCheckError;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.ErrorMsg;
import com.sun.org.apache.xalan.internal.xsltc.compiler.util.Type;
import java.util.List;

final class ElementAvailableCall extends FunctionCall
{
    public ElementAvailableCall(QName fname, List<Expression> arguments) {
        super(fname, arguments);
    }
    
    @Override
    public Type typeCheck(SymbolTable stable) throws TypeCheckError {
        if ((this.argument() instanceof LiteralExpr)) {
            return this._type = Type.Boolean;
        }
        ErrorMsg err = new ErrorMsg("NEED_LITERAL_ERR", "element-available", this);
        throw new TypeCheckError(err);
    }
    
    @Override
    public Object evaluateAtCompileTime() {
        return this.getResult() ? Boolean.TRUE : Boolean.FALSE;
    }
    
    public boolean getResult() {
        try {
            LiteralExpr arg = (LiteralExpr)this.argument();
            String qname = arg.getValue();
            int index = qname.indexOf(58);
            String localName = (index > 0) ? qname.substring(index + 1) : qname;
            return this.getParser().elementSupported(arg.getNamespace(), localName);
        }
        catch (ClassCastException e) {
            return false;
        }
    }
    
    @Override
    public void translate(ClassGenerator classGen, MethodGenerator methodGen) {
        ConstantPoolGen cpg = classGen.getConstantPool();
        boolean result = this.getResult();
        methodGen.getInstructionList().append(new PUSH(cpg, result));
    }
}
